from ngsolve import *

mesh = Mesh("mesh.vol")
fes = H1(mesh, order = 1)
pfp = 1e-2
#mesh.Refine()
#fes.Update()
#mesh.Refine()
#fes.Update()
#mesh.Refine()
#fes.Update()
u = GridFunction(fes, nested = True)
u.Set(atan((sqrt((x - 0.5)**2 + (y - 0.5)**2) - 0.2) / pfp))

vfes = VectorH1(mesh, order = 1)
gu = GridFunction(vfes)
gu.Set(grad(u))
lu = GridFunction(fes)
lu.Set(div(gu))
glu = GridFunction(vfes)
glu.Set(grad(lu))
llu = GridFunction(fes)
llu.Set(div(glu))

VTKOutput(ma = mesh, coefs = [lu, llu], names = ["lap", "bilap"], filename = "lap").Do()
